# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>  # noqa: E501

    The version of the OpenAPI document: 1.41.5
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, List, Optional
from pydantic import BaseModel, Field, conlist
from synctera_client_v1.models.applicant import Applicant
from synctera_client_v1.models.application_type import ApplicationType
from synctera_client_v1.models.credit_application_status import CreditApplicationStatus
from synctera_client_v1.models.review_details import ReviewDetails

class CreditApplication(BaseModel):
    """
    CreditApplication
    """
    applicants: conlist(Applicant, min_items=1) = Field(...)
    application_details: Optional[Dict[str, Any]] = Field(None, description="Details about the application. The exact schema is to be determined with your bank.")
    review_details: Optional[ReviewDetails] = None
    status: Optional[CreditApplicationStatus] = None
    type: ApplicationType = Field(...)
    __properties = ["applicants", "application_details", "review_details", "status", "type"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CreditApplication:
        """Create an instance of CreditApplication from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in applicants (list)
        _items = []
        if self.applicants:
            for _item in self.applicants:
                if _item:
                    _items.append(_item.to_dict())
            _dict['applicants'] = _items
        # override the default output from pydantic by calling `to_dict()` of review_details
        if self.review_details:
            _dict['review_details'] = self.review_details.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CreditApplication:
        """Create an instance of CreditApplication from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return CreditApplication.parse_obj(obj)

        _obj = CreditApplication.parse_obj({
            "applicants": [Applicant.from_dict(_item) for _item in obj.get("applicants")] if obj.get("applicants") is not None else None,
            "application_details": obj.get("application_details"),
            "review_details": ReviewDetails.from_dict(obj.get("review_details")) if obj.get("review_details") is not None else None,
            "status": obj.get("status"),
            "type": obj.get("type")
        })
        return _obj

