# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>  # noqa: E501

    The version of the OpenAPI document: 1.41.5
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, StrictStr, conlist
from synctera_client_v1.models.enhanced_transaction_data1_enhanced_raw_inner import EnhancedTransactionData1EnhancedRawInner

class EnhancedTransactionData1(BaseModel):
    """
    Enriched transaction metadata
    """
    category: Optional[StrictStr] = None
    enhanced_description: Optional[StrictStr] = None
    enhanced_raw: Optional[conlist(EnhancedTransactionData1EnhancedRawInner)] = None
    __properties = ["category", "enhanced_description", "enhanced_raw"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> EnhancedTransactionData1:
        """Create an instance of EnhancedTransactionData1 from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in enhanced_raw (list)
        _items = []
        if self.enhanced_raw:
            for _item in self.enhanced_raw:
                if _item:
                    _items.append(_item.to_dict())
            _dict['enhanced_raw'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> EnhancedTransactionData1:
        """Create an instance of EnhancedTransactionData1 from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return EnhancedTransactionData1.parse_obj(obj)

        _obj = EnhancedTransactionData1.parse_obj({
            "category": obj.get("category"),
            "enhanced_description": obj.get("enhanced_description"),
            "enhanced_raw": [EnhancedTransactionData1EnhancedRawInner.from_dict(_item) for _item in obj.get("enhanced_raw")] if obj.get("enhanced_raw") is not None else None
        })
        return _obj

