# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>  # noqa: E501

    The version of the OpenAPI document: 1.41.5
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist, validator

class FraudRiskData(BaseModel):
    """
    Transaction fraud risk evaluation result
    """
    decision: StrictStr = Field(..., description="The overall decision, based on the vendor response")
    reasons: Optional[conlist(StrictStr)] = Field(None, description="Set of machine-readable descriptions of why the transaction was accepted or declined")
    vendor: StrictStr = Field(..., description="The external vendor used for risk evaluation")
    vendor_reasons: Optional[conlist(StrictStr)] = Field(None, description="List of reasons supplied by the provider")
    __properties = ["decision", "reasons", "vendor", "vendor_reasons"]

    @validator('decision')
    def decision_validate_enum(cls, v):
        if v not in ('ACCEPT', 'DECLINE'):
            raise ValueError("must be one of enum values ('ACCEPT', 'DECLINE')")
        return v

    @validator('reasons')
    def reasons_validate_enum(cls, v):
        if v is None:
            return v
        for i in v:
            if i not in ('SUSPECTED_FRAUD', 'TRANSACTION_ACCEPTED', 'TRANSACTION_NOT_PERMITTED'):
                raise ValueError("each list item must be one of ('SUSPECTED_FRAUD', 'TRANSACTION_ACCEPTED', 'TRANSACTION_NOT_PERMITTED')")
        return v

    @validator('vendor')
    def vendor_validate_enum(cls, v):
        if v not in ('FEEDZAI', 'NONE'):
            raise ValueError("must be one of enum values ('FEEDZAI', 'NONE')")
        return v

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> FraudRiskData:
        """Create an instance of FraudRiskData from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> FraudRiskData:
        """Create an instance of FraudRiskData from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return FraudRiskData.parse_obj(obj)

        _obj = FraudRiskData.parse_obj({
            "decision": obj.get("decision"),
            "reasons": obj.get("reasons"),
            "vendor": obj.get("vendor"),
            "vendor_reasons": obj.get("vendor_reasons")
        })
        return _obj

