# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>  # noqa: E501

    The version of the OpenAPI document: 1.41.5
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Optional
from pydantic import BaseModel, Field, StrictStr
from synctera_client_v1.models.application_type import ApplicationType
from synctera_client_v1.models.restricted_application_details import RestrictedApplicationDetails
from synctera_client_v1.models.restricted_application_status import RestrictedApplicationStatus

class RestrictedApplicationResponse(BaseModel):
    """
    RestrictedApplicationResponse
    """
    creation_time: datetime = Field(..., description="Application creation timestamp in RFC3339 format")
    description: Optional[StrictStr] = Field(None, description="A description of the restricted account application")
    id: StrictStr = Field(..., description="Generated ID for the application")
    last_updated_time: datetime = Field(..., description="Timestamp of the last application modification in RFC3339 format")
    application_details: RestrictedApplicationDetails = Field(...)
    business_id: Optional[StrictStr] = Field(None, description="Business ID for the application. An application must have either a Business or a customer associated with it.")
    customer_id: Optional[StrictStr] = Field(None, description="Customer ID for the application. An application must have either a Business or a customer associated with it.")
    status: RestrictedApplicationStatus = Field(...)
    type: ApplicationType = Field(...)
    __properties = ["creation_time", "description", "id", "last_updated_time", "application_details", "business_id", "customer_id", "status", "type"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> RestrictedApplicationResponse:
        """Create an instance of RestrictedApplicationResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "creation_time",
                            "id",
                            "last_updated_time",
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of application_details
        if self.application_details:
            _dict['application_details'] = self.application_details.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> RestrictedApplicationResponse:
        """Create an instance of RestrictedApplicationResponse from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return RestrictedApplicationResponse.parse_obj(obj)

        _obj = RestrictedApplicationResponse.parse_obj({
            "creation_time": obj.get("creation_time"),
            "description": obj.get("description"),
            "id": obj.get("id"),
            "last_updated_time": obj.get("last_updated_time"),
            "application_details": RestrictedApplicationDetails.from_dict(obj.get("application_details")) if obj.get("application_details") is not None else None,
            "business_id": obj.get("business_id"),
            "customer_id": obj.get("customer_id"),
            "status": obj.get("status"),
            "type": obj.get("type")
        })
        return _obj

