# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>  # noqa: E501

    The version of the OpenAPI document: 1.41.5
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, List
from pydantic import BaseModel, Field, StrictStr, conlist
from synctera_client_v1.models.transaction_line_v0 import TransactionLineV0

class TransactionDataV0(BaseModel):
    """
    TransactionDataV0
    """
    external_data: Dict[str, Any] = Field(..., description="an unstructured json blob representing additional transaction information supplied by the integrator.")
    lines: conlist(TransactionLineV0) = Field(..., description="The set of accounting entries associated with this transaction. For example, a debit to a customer account will have a corresponding credit in a general ledger account.")
    memo: StrictStr = Field(...)
    metadata: Dict[str, Any] = Field(...)
    __properties = ["external_data", "lines", "memo", "metadata"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> TransactionDataV0:
        """Create an instance of TransactionDataV0 from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in lines (list)
        _items = []
        if self.lines:
            for _item in self.lines:
                if _item:
                    _items.append(_item.to_dict())
            _dict['lines'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> TransactionDataV0:
        """Create an instance of TransactionDataV0 from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return TransactionDataV0.parse_obj(obj)

        _obj = TransactionDataV0.parse_obj({
            "external_data": obj.get("external_data"),
            "lines": [TransactionLineV0.from_dict(_item) for _item in obj.get("lines")] if obj.get("lines") is not None else None,
            "memo": obj.get("memo"),
            "metadata": obj.get("metadata")
        })
        return _obj

